## gdb 16.3

=== gdb/features/Makefile ===
# Copyright (C) 2007-2024 Free Software Foundation, Inc.

# This file is part of GDB.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


# This file requires GNU make!

# This Makefile updates files in ../regformats from their XML master
# copies.  Because this relies on xsltproc, it is not normally run
# during the build process; it should be run by hand when one of the
# affected XML files is changed, and the results should be kept in the
# GDB repository.

# It can also update the C files in the features directory from their
# XML master copies.  This relies on a GDB linked with expat and that
# is configured to include support for the architecture, so the files
# are kept in the GDB repository.
#
# By default we'll generate all C files, and you must point make at a
# GDB that has been configured with --enable-targets=all:
#
#   make GDB=/path/to/gdb cfiles
#
# To regenerate all C files from scratch:
#
#   make GDB=/path/to/gdb clean-cfiles cfiles
#
# To generate specific C files, you can override the XMLTOC and
# FEATURE_XMLFILES make variables:
#
#   make GDB=/path/to/gdb XMLTOC="xml files" FEATURE_XMLFILES="xml files" cfiles

# List of .dat files to create in ../regformats/
WHICH = mips-linux mips-dsp-linux \
	mips64-linux mips64-dsp-linux \
	or1k-linux \
	rs6000/powerpc-32 \
	rs6000/powerpc-32l rs6000/powerpc-altivec32l rs6000/powerpc-e500l \
	rs6000/powerpc-64l rs6000/powerpc-altivec64l rs6000/powerpc-vsx32l \
	rs6000/powerpc-vsx64l \
	rs6000/powerpc-isa205-32l rs6000/powerpc-isa205-64l \
	rs6000/powerpc-isa205-altivec32l rs6000/powerpc-isa205-altivec64l \
	rs6000/powerpc-isa205-vsx32l rs6000/powerpc-isa205-vsx64l \
	rs6000/powerpc-isa205-ppr-dscr-vsx32l \
	rs6000/powerpc-isa205-ppr-dscr-vsx64l \
	rs6000/powerpc-isa207-vsx32l rs6000/powerpc-isa207-vsx64l \
	rs6000/powerpc-isa207-htm-vsx32l \
	rs6000/powerpc-isa207-htm-vsx64l \
	s390-linux32 s390-linux64 s390x-linux64 \
	s390-linux32v1 s390-linux64v1 s390x-linux64v1 \
	s390-linux32v2 s390-linux64v2 s390x-linux64v2 \
	s390-te-linux64 s390x-te-linux64 s390-vx-linux64 s390x-vx-linux64 \
	s390-tevx-linux64 s390x-tevx-linux64 \
	s390-gs-linux64 s390x-gs-linux64 \
	tic6x-c64xp-linux tic6x-c64x-linux tic6x-c62x-linux

# Record which registers should be sent to GDB by default after stop.
mips-expedite = r29,pc
mips-dsp-expedite = r29,pc
mips64-expedite = r29,pc
mips64-dsp-expedite = r29,pc
or1k-expedite = r1,npc
powerpc-expedite = r1,pc
s390-linux32-expedite = r14,r15,pswa
s390-linux32v1-expedite = r14,r15,pswa
s390-linux32v2-expedite = r14,r15,pswa
s390-linux64-expedite = r14l,r15l,pswa
s390-linux64v1-expedite = r14l,r15l,pswa
s390-linux64v2-expedite = r14l,r15l,pswa
s390-te-linux64-expedite = r14l,r15l,pswa
s390-vx-linux64-expedite = r14l,r15l,pswa
s390-tevx-linux64-expedite = r14l,r15l,pswa
s390-gs-linux64-expedite = r14,r15,pswa
s390x-expedite = r14,r15,pswa
tic6x-expedite = A15,PC


XSLTPROC = xsltproc
outdir = ../regformats
OUTPUTS = $(patsubst %,$(outdir)/%.dat,$(WHICH))

# For targets without feature based target descriptions,
# the set of xml files we'll generate .c files for GDB from.  By
# default we'll build all .c files, which requires an
# --enable-targets=all GDB.  You can override this by passing XMLTOC
# to make on the command line.
XMLTOC = \
	microblaze-with-stack-protect.xml \
	microblaze.xml \
	mips-dsp-linux.xml \
	mips-linux.xml \
	mips64-dsp-linux.xml \
	mips64-linux.xml \
	nds32.xml \
	or1k.xml \
	or1k-linux.xml \
	rs6000/powerpc-32.xml \
	rs6000/powerpc-32l.xml \
	rs6000/powerpc-403.xml \
	rs6000/powerpc-403gc.xml \
	rs6000/powerpc-405.xml \
	rs6000/powerpc-505.xml \
	rs6000/powerpc-601.xml \
	rs6000/powerpc-602.xml \
	rs6000/powerpc-603.xml \
	rs6000/powerpc-604.xml \
	rs6000/powerpc-64.xml \
	rs6000/powerpc-64l.xml \
	rs6000/powerpc-7400.xml \
	rs6000/powerpc-750.xml \
	rs6000/powerpc-860.xml \
	rs6000/powerpc-altivec32.xml \
	rs6000/powerpc-altivec32l.xml \
	rs6000/powerpc-altivec64.xml \
	rs6000/powerpc-altivec64l.xml \
	rs6000/powerpc-e500.xml \
	rs6000/powerpc-e500l.xml \
	rs6000/powerpc-isa205-32l.xml \
	rs6000/powerpc-isa205-64l.xml \
	rs6000/powerpc-isa205-altivec32l.xml \
	rs6000/powerpc-isa205-altivec64l.xml \
	rs6000/powerpc-isa205-vsx32l.xml \
	rs6000/powerpc-isa205-vsx64l.xml \
	rs6000/powerpc-isa205-ppr-dscr-vsx32l.xml \
	rs6000/powerpc-isa205-ppr-dscr-vsx64l.xml \
	rs6000/powerpc-isa207-vsx32l.xml \
	rs6000/powerpc-isa207-vsx64l.xml \
	rs6000/powerpc-isa207-htm-vsx32l.xml \
	rs6000/powerpc-isa207-htm-vsx64l.xml \
	rs6000/powerpc-vsx32.xml \
	rs6000/powerpc-vsx32l.xml \
	rs6000/powerpc-vsx64.xml \
	rs6000/powerpc-vsx64l.xml \
	rs6000/rs6000.xml \
	rx.xml \
	s390-linux32.xml \
	s390-linux32v1.xml \
	s390-linux32v2.xml \
	s390-linux64.xml \
	s390-linux64v1.xml \
	s390-linux64v2.xml \
	s390-te-linux64.xml \
	s390x-linux64.xml \
	s390x-linux64v1.xml \
	s390x-linux64v2.xml \
	s390x-te-linux64.xml \
	s390-tevx-linux64.xml \
	s390-vx-linux64.xml \
	s390x-tevx-linux64.xml \
	s390x-vx-linux64.xml \
	s390-gs-linux64.xml \
	s390x-gs-linux64.xml \
	sparc/sparc32-solaris.xml \
	sparc/sparc64-solaris.xml \
	z80.xml

TDESC_CFILES = $(patsubst %.xml,%.c,$(XMLTOC))
GDB = false

#Targets which use feature based target descriptions.
aarch64-feature = 1
arm-feature = 1
i386-feature = 1
loongarch-feature = 1
riscv-feature = 1
tic6x-feature = 1

all: $(OUTPUTS)

$(outdir)/%.dat: %.xml number-regs.xsl sort-regs.xsl gdbserver-regs.xsl
	echo "# THIS FILE IS GENERATED.  -*- buffer-read-only: t -*- vi :set ro:" > $(outdir)/$*.tmp
	echo "# Generated from: $<" >> $(outdir)/$*.tmp
	echo "name:`echo $(notdir $*) | sed 's/-/_/g'`" >> $(outdir)/$*.tmp
	$(if $($(firstword $(subst /, ,$(subst -, ,$*)))-feature), echo "feature:1") >> $(outdir)/$*.tmp
	echo "xmltarget:$(<F)" >> $(outdir)/$*.tmp
	echo "expedite:$(if $($*-expedite),$($*-expedite),$($(firstword $(subst -, ,$(notdir $*)))-expedite))" \
	  >> $(outdir)/$*.tmp
	$(XSLTPROC) --path "$(PWD)" --xinclude print-osabi.xsl $< \
	  >> $(outdir)/$*.tmp
	$(XSLTPROC) --path "$(PWD)" --xinclude number-regs.xsl $< | \
	  $(XSLTPROC) sort-regs.xsl - | \
	  $(XSLTPROC) gdbserver-regs.xsl - >> $(outdir)/$*.tmp
	sh ../../move-if-change $(outdir)/$*.tmp $(outdir)/$*.dat

# For targets with feature based target descriptions,
# the set of xml files we'll generate .c files for GDB from.
FEATURE_XMLFILES = aarch64-core.xml \
	aarch64-fpu.xml \
	aarch64-pauth.xml \
	aarch64-mte.xml \
	arc/v1-core.xml \
	arc/v1-aux.xml \
	arc/v2-core.xml \
	arc/v2-aux.xml \
	arm/arm-core.xml \
	arm/arm-fpa.xml \
	arm/arm-m-profile.xml \
	arm/arm-m-profile-mve.xml \
	arm/arm-m-system.xml \
	arm/arm-m-profile-with-fpa.xml \
	arm/arm-secext.xml \
	arm/arm-tls.xml \
	arm/arm-vfpv2.xml \
	arm/arm-vfpv3.xml \
	arm/xscale-iwmmxt.xml \
	cskyv2-linux.xml \
	i386/32bit-core.xml \
	i386/32bit-sse.xml \
	i386/32bit-linux.xml \
	i386/32bit-avx.xml \
	i386/32bit-avx512.xml \
	i386/32bit-segments.xml \
	i386/64bit-avx512.xml \
	i386/64bit-core.xml \
	i386/64bit-segments.xml \
	i386/64bit-avx.xml \
	i386/64bit-linux.xml \
	i386/64bit-sse.xml \
	i386/pkeys.xml \
	i386/x32-core.xml \
	loongarch/base32.xml \
	loongarch/base64.xml \
	loongarch/fpu.xml \
	loongarch/lsx.xml \
	loongarch/lasx.xml \
	loongarch/lbt.xml \
	riscv/rv32e-xregs.xml \
	riscv/32bit-cpu.xml \
	riscv/32bit-fpu.xml \
	riscv/64bit-cpu.xml \
	riscv/64bit-fpu.xml \
	tic6x-c6xp.xml \
	tic6x-core.xml \
	tic6x-gp.xml

FEATURE_CFILES = $(patsubst %.xml,%.c,$(FEATURE_XMLFILES))

cfiles: $(TDESC_CFILES) $(FEATURE_CFILES)

$(TDESC_CFILES): %.c: %.xml
	$(GDB) -nx -q -batch -ex 'maint print c-tdesc $<' > $@.tmp
	sh ../../move-if-change $@.tmp $@

$(FEATURE_CFILES): %.c: %.xml.tmp
	$(GDB) -nx -q -batch \
	  -ex 'maint print c-tdesc -single-feature $<' > $@.tmp
	sh ../../move-if-change $@.tmp $@
	rm $<

# %.xml is the XML file for each target description feature, and
# %.xml.tmp is the XML file target description which only includes
# one target description feature.

%.xml.tmp: %.xml
	echo "<?xml version=\"1.0\"?>" > $@.tmp
	echo "<!DOCTYPE target SYSTEM \"gdb-target.dtd\">" >> $@.tmp
	echo "<target>" >> $@.tmp
	echo "  <xi:include href=\"$(notdir $<)\"/>" >> $@.tmp
	echo "</target>" >> $@.tmp
	sh ../../move-if-change $@.tmp $@

# 'all' doesn't build the C files, so don't delete them in 'clean'
# either.
clean-cfiles:
	rm -f $(TDESC_CFILES) $(FEATURE_CFILES)

clean:
	rm -f $(OUTPUTS)

=== gdb/syscalls/Makefile ===
# Copyright (C) 2022-2024 Free Software Foundation, Inc.

# This file is part of GDB.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Generate .xml files from .xml.in files.

FILES=$(shell ls *.xml.in | grep -v linux-defaults.xml.in | sed 's/\.in//')

all:
	for f in $(FILES); do \
	  xsltproc --output $$f apply-defaults.xsl $$f.in; \
	done

=== zlib/contrib/minizip/Makefile ===
CC=cc
CFLAGS := $(CFLAGS) -O -I../..

UNZ_OBJS = miniunz.o unzip.o ioapi.o ../../libz.a
ZIP_OBJS = minizip.o zip.o   ioapi.o ../../libz.a

.c.o:
	$(CC) -c $(CFLAGS) $*.c

all: miniunz minizip

miniunz:  $(UNZ_OBJS)
	$(CC) $(CFLAGS) -o $@ $(UNZ_OBJS)

minizip:  $(ZIP_OBJS)
	$(CC) $(CFLAGS) -o $@ $(ZIP_OBJS)

test:	miniunz minizip
	@rm -f test.*
	@echo hello hello hello > test.txt
	./minizip test test.txt
	./miniunz -l test.zip
	@mv test.txt test.old
	./miniunz test.zip
	@cmp test.txt test.old
	@rm -f test.*

clean:
	/bin/rm -f *.o *~ minizip miniunz test.*

=== debian/changelog ===
gdb (16.3-5ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable (LP: #2130723). Remaining changes:
    - import upstream tarball for building manpages
    - d/control:
      + added gdb-doc package
      + added (build-)dependency libc6-dbg on armhf
      + exclude libsource-highlight-dev on i386
      + moved libc-dbg from suggests to recommends
    - d/control.in:
      + added (build-)dependency libc6-dbg on armhf
      + exclude libsource-highlight-dev on i386
      + moved libc-dbg from suggests to recommends
    - d/p/gdb-strings.patch: fix grammar in warning message
    - d/p/ptrace-error-verbosity.patch: try to make the PTRACE scope sysctl
      more discoverable via a verbose error message when failures happen.
    - d/p/series: disable gfdl-dont-build-manpages.patch
    - debian/gdb.install & debian/gdbserver.install:
      + include manpages in binary packages
    - d/rules:
      + skip tests on armhf, hanging on the buildds
      + disable lto on ppc64el
      + configure with --disable-werror
      + disable configure with --disable-sim
      + clean gdb/doc/GDBvn.texi before build
      + show test summary after test run
      + disable man-page installation (moved to *.install files)
  * Drop Chnges:
    - d/rules:
      + explicitly build with hardening=-all,+format.
        This was not doing anything - DEB_BUILD_MAINT_OPTIONS
        were overriden to hardening=+all on the next line.

 -- Vladimir Petko <vladimir.petko@canonical.com>  Thu, 06 Nov 2025 08:32:59 +0100

gdb (16.3-5) unstable; urgency=medium

  * d/rules: Remove unused FORCE_CONTROL variable.
  * d/salsa-ci.yml: Disable nocheck, disable blhc pipeline.
    The package should now support 'make check' out of the box.  Also, the
    blhc pipeline has been failing for a while due to missing compiler
    flags when compiling some submodules (opcodes, for example).
  * d/p/fix-hurd-amd64-warning-osabi.patch: Fix osabi warning on Hurd amd64.
    (Closes: #1113764)

 -- Sergio Durigan Junior <sergiodj@debian.org>  Fri, 05 Sep 2025 14:20:51 -0400

gdb (16.3-4) unstable; urgency=medium

  * Install gcore on all architectures.
    - d/gdb.install: Reinstate usr/bin/gcore.
    - d/rules: Remove conditional to install gcore on non-hurd-amd64, as
      it's not necessary anymore.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sun, 24 Aug 2025 13:22:05 -0400

gdb (16.3-3) unstable; urgency=medium

  * d/rules: Remove arch-specific files that we don't ship.
  * d/rules: Invoke 'rm' with '-v'.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sat, 23 Aug 2025 22:40:47 -0400

gdb (16.3-2) unstable; urgency=medium

  * d/control{,.in}: Put Debian GDB Team as maintainer.
    Also, move Héctor and I to Uploaders.
  * d/gdb.lintian-overrides: Remove mismatched entries.
  * d/copyright: Fix old-fsf-address-in-copyright-file.
  * d/compat: Remove file.
  * d/control: Migrate to debhelper-compat 13.
  * d/control: Remove unnecessary Rules-Requires-Root binary-targets.
  * d/control: Remove unnecessary ${python3:Depends}.
  * d/rules: Modernize; use dh sequencer.
  * d/s/lintian-overrides: Remove no-dh-sequencer override.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sat, 23 Aug 2025 20:18:48 -0400

gdb (16.3-1ubuntu2) questing; urgency=medium

  * Rebuild to include updated RISC-V base ISA RVA23

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Thu, 28 Aug 2025 19:19:04 +0000

gdb (16.3-1ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2118491). Remaining changes:
    - import upstream tarball for building manpages
    - d/control:
      + added gdb-doc package
      + added (build-)dependency libc6-dbg on armhf
      + exclude libsource-highlight-dev on i386
      + moved libc-dbg from suggests to recommends
    - d/control.in:
      + added (build-)dependency libc6-dbg on armhf
      + exclude libsource-highlight-dev on i386
      + moved libc-dbg from suggests to recommends
    - d/p/gdb-strings.patch: fix grammar in warning message
    - d/p/ptrace-error-verbosity.patch: try to make the PTRACE scope sysctl
      more discoverable via a verbose error message when failures happen.
    - d/p/series: disable gfdl-dont-build-manpages.patch
    - debian/gdb.install & debian/gdbserver.install:
      + include manpages in binary packages
    - d/rules:
      + skip tests on armhf, hanging on the buildds
      + disable lto on ppc64el
      + configure with --disable-werror
      + disable configure with --disable-sim
      + clean gdb/doc/GDBvn.texi before build
      + show test summary after test run
      + disable man-page installation (moved to *.install files)
      + explicitly build with hardening=-all,+format.
  * Dropped changes:
    - d/rules: unnecessary delta splitting dh_installchangelogs call for gdb
      and gdbserver packages.

 -- Mateus Rodrigues de Morais <mateus.morais@canonical.com>  Thu, 31 Jul 2025 11:48:28 -0300

gdb (16.3-1) unstable; urgency=medium

  * d/u/signing-key.asc: Remove problematic key.
    Importing a new version of GDB would lead to uscan errors regarding
    this key.  Moreover, since we're repacking the tarball anyway, the
    signature verification would always fail.
  * d/watch: Remove pgpsigurlmangle option.
  * New upstream version 16.3

 -- Sergio Durigan Junior <sergiodj@debian.org>  Mon, 21 Apr 2025 12:29:40 -0400

gdb (16.2-8ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - import upstream tarball for building manpages
    - debian/control:
      - added gdb-doc package
      - added (build-)dependency libc6-dbg on armhf
      - exclude libsource-highlight-dev on i386
    - debian/control.in:
      - added (build-)dependency libc6-dbg on armhf
      - exclude libsource-highlight-dev on i386
    - debian/patches/series:
      - apply patches gdb-strings and ptrace-error-verbosity
    - debian/gdb.install & debian/gdbserver.install:
      - include manpages in binary packages


=== debian/control ===
Source: gdb
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GDB Team <team+gdb@tracker.debian.org>
Uploaders: Héctor Orón Martínez <zumbi@debian.org>, Sergio Durigan Junior <sergiodj@debian.org>
Section: devel
Priority: optional
Standards-Version: 4.7.2
Rules-Requires-Root: no
Build-Depends:
# Packaging deps
               debhelper-compat (= 13),
               xz-utils,
# Other tool deps
               autoconf,
               libtool,
               gettext,
               bison,
               dejagnu,
               flex,
               procps,
               gobjc,
               mig [hurd-any],
# TeX[info] deps
               texinfo (>= 4.7-2.2),
               texlive-base <!nodoc>,
# Libdev deps
               libexpat1-dev,
               libncurses-dev,
               libreadline-dev,
               zlib1g-dev,
               liblzma-dev,
               libzstd-dev,
               libbabeltrace-dev,
               libipt-dev [amd64 i386 x32],
               libsource-highlight-dev [!i386],
	       libxxhash-dev,
	       libmpfr-dev,
               pkgconf,
# Python build
               python3-dev,
               libunwind-dev [ia64],
# debuginfod
               libdebuginfod-dev [linux-any],
               libc6-dbg [armhf],
# Reproducible build
               faketime,
Vcs-Git: https://salsa.debian.org/gdb-team/gdb.git
Vcs-Browser: https://salsa.debian.org/gdb-team/gdb
Homepage: https://www.gnu.org/s/gdb/

Package: gdb
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libc6-dbg [armhf],
Recommends: libc-dbg
Suggests: gdb-doc,
          gdbserver [linux-any],
Breaks: gdb-minimal (<< 15.2-2~exp1)
Replaces: gdb-minimal (<< 15.2-2~exp1)
Provides: gdb-minimal
Description: GNU Debugger
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, gdb supports C, C++, D,
 Objective-C, Fortran, Java, OpenCL C, Pascal, assembly, Modula-2,
 Go, and Ada. A must-have for any serious programmer.

Package: gdb-multiarch
Architecture: any
Depends: gdb (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: GNU Debugger (with support for multiple architectures)
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, gdb supports C, C++, D,
 Objective-C, Fortran, Java, OpenCL C, Pascal, assembly, Modula-2,
 Go, and Ada. A must-have for any serious programmer.
 .
 This package contains a version of GDB which supports multiple
 target architectures.

Package: gdb-minimal
Architecture: all
Section: oldlibs
Multi-Arch: foreign
Depends: gdb (>= 15.2-2~exp1), ${misc:Depends}
Description: GNU Debugger (minimal version - dummy transitional package)
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, gdb supports C, C++, D,
 Objective-C, Fortran, Java, OpenCL C, Pascal, assembly, Modula-2,
 Go, and Ada. A must-have for any serious programmer.
 .
 This is a transitional package.  It can be safely removed.

Package: gdbserver
Architecture: amd64 armel armhf arm64 i386 ia64 m68k mips mipsel mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390 s390x x32
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: gdb (<< 7.0.1-1)
Description: GNU Debugger (remote server)
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, gdb supports C, C++, D,
 Objective-C, Fortran, Java, OpenCL C, Pascal, assembly, Modula-2,
 Go, and Ada. A must-have for any serious programmer.
 .
 This package contains gdbserver.  Install this to debug remotely
 from another system where GDB is installed.

Package: gdb-source
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: GNU Debugger (source)
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, gdb supports C, C++, D,
 Objective-C, Fortran, Java, OpenCL C, Pascal, assembly, Modula-2,
 Go, and Ada. A must-have for any serious programmer.
 .
 This package contains the sources and patches which are needed
 to build GDB.

Package: gdb-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Breaks: gdb (<< 7.8), gdbserver (<< 7.8)
Replaces: gdb (<< 7.8), gdbserver (<< 7.8)
Description: The GNU Debugger Documentation
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, it works for C, C++, Fortran,
 Modula 2 and Java programs. A must-have for any serious
 programmer.
 .
 This package contains the GDB manual.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk

SPACE := $(EMPTY) $(EMPTY)
COMMA = ,

# The top-level configure script fails to pass these down properly ...
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el))
  export DEB_BUILD_MAINT_OPTIONS += optimize=-lto
endif

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CXXFLAGS += -fPIC
CFLAGS += -fPIC
export $(DPKG_BUILDFLAGS_LIST)

# Ensure texlive respects DEB_TIMESTAMP
export FORCE_SOURCE_DATE = 1
# Also force "TeX output" string in dvi file, thus %DVIPSSource in the ps file
FAKETIME = TZ=UTC faketime "$(shell TZ=UTC date +"%Y-%m-%d %T" --date=@$(DEB_TIMESTAMP))"

# Rather paranoid than sorry. Make the shell exit with an error if an
# untested command fails.
SHELL += -e

export INSTALL = /usr/bin/install -p

derivative = $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
		elif dpkg-vendor --derives-from Debian; then echo Debian; \
		else echo Unknown; fi)

# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

nodoc_profile = $(if $(filter nodoc,$(DEB_BUILD_PROFILES)),no,yes)

# Don't include docs with GFDL invariant sections
GFDL_INVARIANT_FREE = yes
ifeq ($(derivative),Ubuntu)
  GFDL_INVARIANT_FREE = no
endif

with_doc = no
ifneq ($(GFDL_INVARIANT_FREE),yes)
  ifneq ($(nodoc_profile),yes)
    with_doc = yes
  endif
endif

with_multiarch = $(if $(filter pkg.gdb.no-multiarch,$(DEB_BUILD_PROFILES)),no,yes)

# ---------- settings for cross builds ----------

# Cross configuration support.  Check for an environment variable
# $GDB_TARGET, or a file debian/target.
ifndef GDB_TARGET
  DEBIAN_TARGET_FILE := $(strip $(shell cat debian/target 2>/dev/null))
  ifneq ($(DEBIAN_TARGET_FILE),)
    GDB_TARGET := $(DEBIAN_TARGET_FILE)
  endif
endif

DEB_TARGET_ALIAS ?= $(DEB_TARGET_GNU_TYPE)

ifneq ($(GDB_TARGET),)
  configure_target_args = --with-gdb-datadir="\$${prefix}/share/gdb-$(DEB_TARGET_GNU_TYPE)"
endif

ifeq ($(DEB_TARGET_ARCH),)
  $(error GDB_TARGET value "$(GDB_TARGET)" is not a valid Debian architecture)
endif

ifdef GDB_TARGET
  DEB_CROSS = yes
  # TP: Target Prefix. Used primarily as a prefix for cross tool
  #     names (e.g. powerpc-linux-gcc).
  # TS: Target Suffix. Used primarily at the end of cross compiler
  #     package names (e.g. gcc-powerpc).
  TP = $(DEB_TARGET_ALIAS)-
  TS = -$(DEB_TARGET_ALIAS)
endif

# ---------- configure options, architecture specific ----------

ifeq ($(DEB_HOST_GNU_CPU),ia64)
  arch_config_args = --with-libunwind-ia64
endif

arch_config_args += --with-babeltrace

# Enable Intel Processor Trace (PT) on Linux x86 platform
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
  arch_config_args += --with-intel-pt
endif

ifdef GDB_TARGET
  arch_config_args += \
	--program-prefix=$(TP) \
	--target=$(DEB_TARGET_ALIAS) \
	--with-sysroot=/usr/$(DEB_TARGET_ALIAS)
else
  # To avoid file conflicts, only enable the global gdbinit file for native
  # debuggers.
  arch_config_args += \
	--with-system-gdbinit=/etc/gdb/gdbinit \
	--with-system-gdbinit-dir=/etc/gdb/gdbinit.d
endif

run_tests = yes
ifneq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
  run_tests = disabled by DEB_BUILD_OPTIONS
endif

ifeq (,$(findstring linux, $(DEB_HOST_GNU_SYSTEM)))
  run_tests = only enabled for Linux targets
endif

# FIXME: hanging on the Ubuntu buildds?
#ifneq (,$(filter armhf, $(DEB_HOST_ARCH)))
#  run_tests := not enabled for $(DEB_HOST_ARCH)
#endif

ifdef GDB_TARGET
  run_tests = disabled for cross builds
endif

# List of architectures where tests are flaky (and therefore
# disabled).
FLAKY_TEST_ARCHITECTURES = \
	alpha \
	hppa \
	sparc64 \
	x32

ifneq (,$(filter $(DEB_HOST_ARCH),$(FLAKY_TEST_ARCHITECTURES)))
  run_tests = disable on $(DEB_HOST_ARCH) due to flakiness
endif

# Architectures where gdbserver's libinproctrace is available.
LIBINPROCTRACE_AVAILABLE_ARCHITECTURES = \
	amd64 \
	arm64 \
	i386 \
	ppc64el \
	s390x \
	powerpc \
	ppc64 \
	x32

# ---------- configure options, for all variants ----------

variants = default multiarch

# We pass srcdir explicitly to avoid an extra '/.' at the end of it.  That
# causes a harmless, but ugly, testsuite failure in maint.exp.
common_configure_args = \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--host=$(DEB_HOST_GNU_TYPE) \
	--prefix=/usr \
	--libexecdir="\$${prefix}/lib/gdb" \
	--disable-werror \
	--disable-maintainer-mode \
	--disable-dependency-tracking \
	--disable-silent-rules \
	--disable-gdbtk \
	--disable-shared \
	--with-pkgversion='$(DEB_VENDOR)___$(DEB_VERSION)' \
	--srcdir=$(CURDIR) \
	--disable-readline \
	--with-system-readline \
	--with-expat \
	--with-system-zlib \
	--without-guile \
	--without-babeltrace \
	$(if $(filter linux, $(DEB_HOST_ARCH_OS)),--with-debuginfod) \
	$(arch_config_args) \

#	$(if $(filter $(DEB_HOST_ARCH), armhf arm64 mips mipsel ppc64el riscv64),--disable-sim) \

default_configure_args = \
	$(common_configure_args) \
	$(configure_target_args) \
	--enable-tui \
	--with-lzma \
	--with-python=python3 \
	--with-xxhash \
	--enable-64-bit-bfd

multiarch_configure_args = \
	$(default_configure_args) \
	--enable-targets=all \
	--enable-obsolete \
	--disable-sim

builddir_default	= build/default
builddir_multiarch	= build/multiarch
builddir_source		= build/gdb

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -f gdb/doc/GDBvn.texi

# There's no need to run autoreconf as upstream already ships a
# working configure script.
override_dh_autoreconf:

# Configure GDB.
# First and only argument is the build directory.
define configure-gdb
mkdir -p $(builddir_$(1))
@echo "gdb-$(1): configure with: $(subst ___, ,$(foreach i,$($(1)_configure_args),$(i)\n\t))"
cd $(builddir_$(1)) && ../../configure $(subst ___,$(SPACE),$($(1)_configure_args))
endef

override_dh_auto_configure-arch:
	$(call configure-gdb,default)
ifeq ($(with_multiarch),yes)
	$(call configure-gdb,multiarch)
endif

override_dh_auto_configure-indep:

# Build GDB.
# First and only argument is the build directory.
define build-gdb
$(MAKE) V=1 -C $(builddir_$(1)) $(NJOBS)
endef

override_dh_auto_build-arch:
	$(call build-gdb,default)
ifeq ($(with_multiarch),yes)
	$(call build-gdb,multiarch)
endif
	$(FAKETIME) $(MAKE) -C $(builddir_default)/gdb/doc refcard.dvi refcard.ps
ifeq ($(with_doc),yes)
	$(MAKE) -C $(builddir_default) info
	$(MAKE) -C $(builddir_default)/gdb/doc pdf html
endif

override_dh_auto_build-indep:

# GDB's testsuite has historically been flaky and its results haven't
# been very trustworthy.  Instead of running the entire testsuite (and
# wasting a lot of time and CPU), pick only a subset of tests that are
# known to be non-flaky.  If any of these fail, something is really
# wrong.
#
# This list was inspired by
# https://sourceware.org/git/?p=builder.git;a=blob;f=builder/master.cfg
TESTS_NON_FLAKY = \
	gdb.base/break-always.exp \
	gdb.base/break-caller-line.exp \
	gdb.base/break-entry.exp \
	gdb.base/break.exp \
	gdb.base/break-fun-addr.exp \
	gdb.base/break-idempotent.exp \
	gdb.base/break-include.exp \
	gdb.base/break-inline.exp \
	gdb.base/break-main-file-remove-fail.exp \
	gdb.base/break-on-linker-gcd-function.exp \
	gdb.base/breakpoint-in-ro-region.exp \
	gdb.base/breakpoint-shadow.exp \
	gdb.base/break-probes.exp \
	gdb.gdb/unittest.exp \
	gdb.server/unittest.exp

define test-gdb
$(MAKE) -C $(builddir_$(1))/gdb \
	check//unix check//native-gdbserver check//native-extended-gdbserver \
	TESTS="$(TESTS_NON_FLAKY)"
endef

override_dh_auto_test-arch:
ifeq ($(run_tests),yes)
#	Run the non-flaky tests.
#
#	Don't parallelize because things can get racy, and we're not
#	dealing with that many tests anyway.
	$(call test-gdb,default)
ifeq ($(with_multiarch),yes)
	$(call test-gdb,multiarch)
endif
	@echo "===== TEST SUMMARY BEGIN ====="

=== debian/watch ===
version=4
  https://ftp.gnu.org/gnu/gdb/gdb-@ANY_VERSION@@ARCHIVE_EXT@ \
  debian debian/sanitize-gdb.sh

## gdb 17.0.50.20250905

=== debian/changelog ===
gdb (17.0.50.20250905-1~exp1) experimental; urgency=medium

  * Import debian/ from unstable.
  * New upstream version 17.0.50.20250905
  * d/p/Port-GDB-to-Hurd-x86_64.patch: Remove; part of upstream now.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Fri, 05 Sep 2025 15:17:42 -0400

## gdb 17.0.90

=== debian/changelog ===
gdb (17.0.90-1~exp2) experimental; urgency=medium

  * d/gbp.conf: Set debian-branch to debian/experimental.
  * d/p/fix-ftbfs-i386.patch: Apply upstream patch to fix FTBFS on i386.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sun, 14 Sep 2025 20:56:35 -0400

gdb (17.0.90-1~exp1) experimental; urgency=medium

  * d/salsa-ci.yml: Ignore debian/experimental branch.
  * New upstream version 17.0.90
  * d/copyright: Remove stanzas for sim/arm/ directory.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sun, 07 Sep 2025 13:43:42 -0400

=== debian/rules ===
--- 
+++ 
@@ -9,10 +9,6 @@
 
 # The top-level configure script fails to pass these down properly ...
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el))
-  export DEB_BUILD_MAINT_OPTIONS += optimize=-lto
-endif
-
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
@@ -123,11 +119,6 @@
   run_tests = only enabled for Linux targets
 endif
 
-# FIXME: hanging on the Ubuntu buildds?
-#ifneq (,$(filter armhf, $(DEB_HOST_ARCH)))
-#  run_tests := not enabled for $(DEB_HOST_ARCH)
-#endif
-
 ifdef GDB_TARGET
   run_tests = disabled for cross builds
 endif
@@ -166,7 +157,6 @@
 	--host=$(DEB_HOST_GNU_TYPE) \
 	--prefix=/usr \
 	--libexecdir="\$${prefix}/lib/gdb" \
-	--disable-werror \
 	--disable-maintainer-mode \
 	--disable-dependency-tracking \
 	--disable-silent-rules \
@@ -183,8 +173,6 @@
 	$(if $(filter linux, $(DEB_HOST_ARCH_OS)),--with-debuginfod) \
 	$(arch_config_args) \
 
-#	$(if $(filter $(DEB_HOST_ARCH), armhf arm64 mips mipsel ppc64el riscv64),--disable-sim) \
-
 default_configure_args = \
 	$(common_configure_args) \
 	$(configure_target_args) \
@@ -206,10 +194,6 @@
 
 %:
 	dh $@
-
-override_dh_auto_clean:
-	dh_auto_clean
-	rm -f gdb/doc/GDBvn.texi
 
 # There's no need to run autoreconf as upstream already ships a
 # working configure script.
@@ -291,4 +275,22 @@
 ifeq ($(with_multiarch),yes)
 	$(call test-gdb,multiarch)
 endif
-	@echo "===== TEST SUMMARY BEGIN ====="
+else
+	@echo "***Tests disabled: $(run_tests) ***"
+endif
+
+override_dh_auto_test-indep:
+
+execute_after_dh_clean: debian/control
+	rm -rf build
+
+	if test -f gdb/version.in.backup; then \
+	  mv -f gdb/version.in.backup gdb/version.in; \
+	fi
+
+	# Prevent gratuitous rebuilds of the BFD documentation, since it
+	# updates the copy in the source directory.
+	find bfd -name bfd.info\* | xargs --no-run-if-empty touch
+
+override_dh_install-arch:
+	# gdb install

## gdb 17.1

=== debian/changelog ===
gdb (17.1-3) unstable; urgency=medium

  * d/rules: Disable tests on loong64.
    This is a temporary measure until upstream GDB adopts a proposed patch
    to fix the issue described in #1125934. (Closes: #1125934)

 -- Sergio Durigan Junior <sergiodj@debian.org>  Fri, 06 Feb 2026 09:42:31 -0500

gdb (17.1-2) unstable; urgency=medium

  * d/control: Bump Standards-Version to 4.7.3; no changes needed.

  [ Vladimir Petko ]
  * - d/rules: create $(builddir_$(1))/sim/common to resolve
      ftbfs (LP: 2138687) (Closes: #1126040)

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #1124547)
    - Cross-translate gobjc build dependency.
    - Multiarchify Python build dependency.
    - cross.patch: Use host flags for chew.c

 -- Sergio Durigan Junior <sergiodj@debian.org>  Tue, 20 Jan 2026 22:48:45 -0500

gdb (17.1-1) unstable; urgency=medium

  * d/salsa-ci.yml: Ignore debian/experimental branch.
  * d/README.Debian: Update links.
  * d/control.in: Sync with d/control.
  * d/rules: Add comments to canned recipes.
  * New upstream version 17.1
  * d/p/Port-GDB-to-Hurd-x86_64.patch: Remove; upstreamed.
  * d/p/fix-hurd-amd64-warning-osabi.patch: Remove; upstreamed.
  * d/copyright: Update.
  * d/s/lintian-overrides: Update.
  * d/watch: Update to version 5.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sun, 21 Dec 2025 15:09:18 -0500

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: gdb
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GDB Team <team+gdb@tracker.debian.org>
+Maintainer: Debian GDB Team <team+gdb@tracker.debian.org>
 Uploaders: Héctor Orón Martínez <zumbi@debian.org>, Sergio Durigan Junior <sergiodj@debian.org>
 Section: devel
 Priority: optional
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Rules-Requires-Root: no
 Build-Depends:
 # Packaging deps
@@ -18,7 +17,7 @@
                dejagnu,
                flex,
                procps,
-               gobjc,
+               gobjc-for-host,
                mig [hurd-any],
 # TeX[info] deps
                texinfo (>= 4.7-2.2),
@@ -32,16 +31,16 @@
                libzstd-dev,
                libbabeltrace-dev,
                libipt-dev [amd64 i386 x32],
-               libsource-highlight-dev [!i386],
+               libsource-highlight-dev,
 	       libxxhash-dev,
 	       libmpfr-dev,
                pkgconf,
 # Python build
-               python3-dev,
+               libpython3-dev,
+               python3-dev:native,
                libunwind-dev [ia64],
 # debuginfod
                libdebuginfod-dev [linux-any],
-               libc6-dbg [armhf],
 # Reproducible build
                faketime,
 Vcs-Git: https://salsa.debian.org/gdb-team/gdb.git
@@ -52,10 +51,9 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         libc6-dbg [armhf],
-Recommends: libc-dbg
 Suggests: gdb-doc,
           gdbserver [linux-any],
+	  libc-dbg
 Breaks: gdb-minimal (<< 15.2-2~exp1)
 Replaces: gdb-minimal (<< 15.2-2~exp1)
 Provides: gdb-minimal
@@ -120,18 +118,3 @@
  .
  This package contains the sources and patches which are needed
  to build GDB.
-
-Package: gdb-doc
-Architecture: all
-Section: doc
-Depends: ${misc:Depends}
-Breaks: gdb (<< 7.8), gdbserver (<< 7.8)
-Replaces: gdb (<< 7.8), gdbserver (<< 7.8)
-Description: The GNU Debugger Documentation
- GDB is a source-level debugger, capable of breaking programs at
- any specific line, displaying variable values, and determining
- where errors occurred. Currently, it works for C, C++, Fortran,
- Modula 2 and Java programs. A must-have for any serious
- programmer.
- .
- This package contains the GDB manual.

=== debian/rules ===
--- 
+++ 
@@ -128,6 +128,7 @@
 FLAKY_TEST_ARCHITECTURES = \
 	alpha \
 	hppa \
+	loong64 \
 	sparc64 \
 	x32
 
@@ -200,9 +201,9 @@
 override_dh_autoreconf:
 
 # Configure GDB.
-# First and only argument is the build directory.
+# First and only argument is the build flavour.
 define configure-gdb
-mkdir -p $(builddir_$(1))
+mkdir -p $(builddir_$(1)) $(builddir_$(1))/sim/common
 @echo "gdb-$(1): configure with: $(subst ___, ,$(foreach i,$($(1)_configure_args),$(i)\n\t))"
 cd $(builddir_$(1)) && ../../configure $(subst ___,$(SPACE),$($(1)_configure_args))
 endef
@@ -216,7 +217,7 @@
 override_dh_auto_configure-indep:
 
 # Build GDB.
-# First and only argument is the build directory.
+# First and only argument is the build flavour.
 define build-gdb
 $(MAKE) V=1 -C $(builddir_$(1)) $(NJOBS)
 endef
@@ -259,6 +260,8 @@
 	gdb.gdb/unittest.exp \
 	gdb.server/unittest.exp
 
+# Test GDB.
+# First and only argument is the build flavour.
 define test-gdb
 $(MAKE) -C $(builddir_$(1))/gdb \
 	check//unix check//native-gdbserver check//native-extended-gdbserver \
@@ -290,7 +293,3 @@
 
 	# Prevent gratuitous rebuilds of the BFD documentation, since it
 	# updates the copy in the source directory.
-	find bfd -name bfd.info\* | xargs --no-run-if-empty touch
-
-override_dh_install-arch:
-	# gdb install
